/*
Boule de neige par Purobaz
a l'occasion du 48h CPC
plus d'infos sur Planete-Casio
c'est mon premier programme en C/C++, soyez indulgents
*/


#include "fxlib.h"
#include "stdio.h"
#include "stdlib.h"
#include "MonochromeLib.h" // merci a PierrotLL
#define arrondi(x) (x-(int)x<.5?(int)x:(int)x+1) // re


int AddIn_main(int isAppli, unsigned short OptionNum)
{
	char traineau[] = {253,255,254,127,254,63,252,63,252,31,254,63,140,31,128,7,128,31,192,39,192,31,192,9,192,1,192,3,111,118,0,1};
	int i, curseur, compteur;
	char neige[60], *pointeur;
	pointeur = &neige;

/* initialisation neige */
	for(i=0 ; i<30 ; i++)
	{
		neige[2*i] = Rand(0, 127);
		neige[2*i+1] = Rand(0, 62);
	}
	
/* menu */
	curseur = 0;
	compteur = 0;
	
	do
	{
/* affichage menu */
		ML_rectangle(0, 0, 127, 63, 0, 0, 1);
		PrintXY(40, 2, "SnowBall", MINI_REV);
		PrintXY(50, 20, "Play", MINI_REV);
		PrintXY(50, 34, "About", MINI_REV);
		PrintXY(50, 48, "Quit", MINI_REV);
		ML_bmp_16_and(traineau, 28, 14+14*curseur);
		Neige(pointeur, compteur, 2);
		ML_display_vram();
		Sleep(50);
		compteur++;

/* gestion des touches */		
		if(IsKeyDown(KEY_CTRL_UP) && curseur>0) curseur--;
		if(IsKeyDown(KEY_CTRL_DOWN) && curseur<2) curseur++;
		if(IsKeyDown(KEY_CTRL_SHIFT))
		{
			for(i=0 ; i<=20 ; i +=2) // petite anim
			{
				ML_rectangle(0, 0, 127, 63, 0, 0, 1);
				PrintXY(40, 2, "SnowBall", MINI_REV);
				PrintXY(50, 20, "Play", MINI_REV);
				PrintXY(50, 34, "About", MINI_REV);
				PrintXY(50, 48, "Quit", MINI_REV);
				ML_bmp_16_and(traineau, 28, 14+14*curseur);
				ML_filled_circle(42+i, 22+14*curseur, 1+arrondi(3*i/20), 0);
				Neige(pointeur, compteur, 5);
				ML_display_vram();
				Sleep(20);
				compteur++;
			}
			
			if(curseur==0) // jeu
			{
				Jeu(pointeur);
			}
			else if(curseur==1) // a propos
			{
				do
				{
					ML_rectangle(0, 0, 127, 63, 0, 0, 1);
					PrintMini(2, 2, "SnowBall - Purobaz 2011", MINI_REV);
					PrintMini(2, 12, "48h CPC - Planete-Casio.com", MINI_REV);
					PrintMini(2, 30, "Move Father Christmas' sleigh", MINI_REV);
					PrintMini(2, 40, "with Left and Right arrows", MINI_REV);
					PrintMini(2, 50, "Throw snowballs with SHIFT", MINI_REV);
					Neige(pointeur, compteur, 2);
					ML_display_vram();
					Sleep(50);
					compteur++;
				}
				while(IsKeyUp(KEY_CTRL_EXE));
			}
			else
			{
			curseur = 3;
			}
		}
		
	}
	while(IsKeyUp(KEY_CTRL_EXIT) && curseur<3);
	
	
	return 1;
}

int Neige(char *neige, int compteur, int modulo) // affiche puis fait descendre la neige
{
	int i;
	for(i=0 ; i<30 ; i++)
	{
		ML_pixel(*(neige+2*i), *(neige+2*i+1), 0);
		if((compteur%modulo)==0)
		{
			*(neige+2*i) += Rand(0, 3)-1;
			*(neige+2*i+1) += 1;
			if(*(neige+2*i)<0 || *(neige+2*i)>127 || *(neige+2*i+1)>63)
			{
				*(neige+2*i) = Rand(0, 127);
				*(neige+2*i+1) = Rand(0, 62);
			}
		}
	}
	return 1;
}

int Jeu(char *pointeur)
{
	char traineau[] = {255,191,254,127,252,127,252,63,248,63,252,127,248,49,224,1,248,1,228,3,248,3,144,3,128,3,192,3,110,246,128,0};
	float tirs[3][3], bonhommes[3][2];
	int i, j, k, xtraineau, charge, nbtir;
	int compteur, boules, score;
	char affichage[3];
	
	
/* initialisation */
	xtraineau = 56;
	charge = 0;
	for(i=0 ; i<3 ; i++)
	{
		tirs[i][0] = 0;
		tirs[i][1] = 0;
		tirs[i][2] = 0;
		bonhommes[i][0] = 0;
		bonhommes[i][1] = 0;
	}
	nbtir = 0;
	compteur = 0;
	boules = 127;
	score = 0;
	

/* boucle principale */
	while(IsKeyUp(KEY_CTRL_EXIT) && boules>0)
	{
/* gestion des touches */
		if(IsKeyDown(KEY_CTRL_LEFT) && xtraineau-2>=0)
		{
			xtraineau -= 2;
		}
		else if(xtraineau<=110)
		{
			xtraineau++;
		}
		if(IsKeyDown(KEY_CTRL_RIGHT) && xtraineau+2<=111) xtraineau += 2;
		if(IsKeyDown(KEY_CTRL_SHIFT) && charge>10 && nbtir<3)
		{
			tirs[nbtir][0] = xtraineau+8;
			tirs[nbtir][1] = 0;
			tirs[nbtir][2] = charge;
			charge = 0;
			nbtir++;
		}
		
		
/* gestion des tirs */
		for(i=0 ; i<nbtir ; i++)
		{
			tirs[i][1]+=3;
			tirs[i][2]-=3;
			
			if(tirs[i][2]<=5 )
			{
				for(k=i ; k<nbtir-1 ; k++) // on decale tous les tirs
				{
					tirs[k][0] = tirs[k+1][0];
					tirs[k][1] = tirs[k+1][1];
					tirs[k][2] = tirs[k+1][2];
				}
				tirs[nbtir][0] = 0;
				tirs[nbtir][1] = 0;
				tirs[nbtir][2] = 0;
				nbtir--;
				i--;
				boules--;
			}
			else
			{
				for(j=0 ; j<3 ; j++)
				{
					
					if(tirs[i][0]>=bonhommes[j][0]+bonhommes[j][1]/10-6 && tirs[i][0]<=bonhommes[j][0]-bonhommes[j][1]/10+6 && tirs[i][1]>=bonhommes[j][1]-1 && tirs[i][1]<=bonhommes[j][1]+2)
					{
						bonhommes[j][0] = 0;
						bonhommes[j][1] = 0;
						score++;
						for(k=i ; k<nbtir-1 ; k++)
						{
							tirs[k][0] = tirs[k+1][0];
							tirs[k][1] = tirs[k+1][1];
							tirs[k][2] = tirs[k+1][2];
						}
						tirs[nbtir][0] = 0;
						tirs[nbtir][1] = 0;
						tirs[nbtir][2] = 0;
						nbtir--;
						i--;
						boules--;
						j = 3; // pour sortir de la boucle
					}
				
				}
			}
			
			if(nbtir==0) break;
		}
		
/* mouvements */
		for(i=0 ; i<3 ; i++)
		{
			if(bonhommes[i][0]!=0) // scroll des bonhommes
			{
				bonhommes[i][0]++;
				if(bonhommes[i][0]>127)
				{
					bonhommes[i][0] = 0;
					bonhommes[i][1] = 0;
				}
			}
			else if(Rand(0, 40)==0) // nouveaux bonhommes
			{
				bonhommes[i][0] = 1;
				bonhommes[i][1] = Rand(2,35);
			}
		}
		if(charge+2<=40) charge += 2;
		compteur++;
		

/* dessin */
		ML_rectangle(0, 0, 127, 63, 0, 0, 1);
		ML_horizontal_line(59, 0, boules, 0);
		ML_rectangle(0, 61, 41, 63, 1, 0, 1);
		ML_horizontal_line(62, 0, charge, 0);
		for(i=0 ; i<3 ; i++)
		{
			if(bonhommes[i][0]!=0)
			{
				ML_filled_circle(arrondi(bonhommes[i][0]), arrondi(37-bonhommes[i][1]), arrondi(4-bonhommes[i][1]/20), 3);
				ML_filled_circle(arrondi(bonhommes[i][0]), arrondi(32-bonhommes[i][1]+2*bonhommes[i][1]/20), arrondi(3-bonhommes[i][1]/20), 3);
			}
		}
		for(i=0 ; i<nbtir ; i++)
		{
			ML_filled_circle(arrondi(tirs[i][0]), arrondi(41-tirs[i][1]), arrondi(3-tirs[i][1]/20), 0);
		}
		
		ML_bmp_16_and(traineau, arrondi(xtraineau), 41);
		Neige(pointeur, compteur, arrondi(2*compteur/500)+3);
		ML_display_vram();
		
		Sleep(40-arrondi(compteur/30));
		
	}
	
/* score */
	if(boules==0)
	{
		while(IsKeyUp(KEY_CTRL_EXIT) && IsKeyUp(KEY_CTRL_EXE))
		{
		ML_rectangle(0, 0, 127, 63, 0, 0, 1);
		sprintf(affichage,"Score : %d",score);
		PrintXY(20, 25, affichage, MINI_REV);
		ML_bmp_16_and(traineau, arrondi(xtraineau), 41);
		Neige(pointeur, compteur, 2);
		ML_display_vram();
		Sleep(50);
		compteur++;
		}
	}
	
	return 1;
}


int Rand(int lower, int upper) // merci a PierrotLL
{
    static int a = 123456789;
    static int b = 362436069;
    static int c = 521288629;
    static int d = 88675123;
    int t;
    t = a ^ (a << 11);
    a = b;
    b = c;
    c = d;
    return (d = d ^ (d >> 19) ^ (t ^ (t >> 8 )))%upper + lower;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section
